#pragma once

#ifndef ERROR_H
#define ERROR_H

enum error {
	ERROR_SUCCESS,
	ERROR_OUT_OF_MEMORY,
	ERROR_INSUFFICIENT_EVALS,
	ERROR_INSUFFICIENT_CALLS,
	ERROR_UNRECOGNIZED_OPCODE,

	ERROR_LABEL_REDEFINE,
	ERROR_LABEL_UNDEFINED,
	ERROR_RECORD_REDEFINE,
	ERROR_RECORD_UNDEFINED,
	ERROR_PROPERTY_REDEFINE,
	ERROR_PROPERTY_UNDEFINED,

	ERROR_UNEXPECTED_TYPE,
	ERROR_INDEX_OUT_OF_RANGE,
	ERROR_STACK_OVERFLOW,
	ERROR_VARIABLE_UNDEFINED,

	ERROR_UNRECOGNIZED_TOKEN,
	ERROR_UNRECOGNIZED_CONTROL_SEQ,
	ERROR_UNEXPECTED_CHAR,
	ERROR_UNEXPECTED_TOKEN,
	ERROR_CANNOT_OPEN_FILE
};

#define ERROR_ALLOC_CHECK(PTR) if((PTR) == NULL) { return 0; }

void error_info(enum error error);

#endif // !ERROR_H
